context("Inconsistent output length")

test_that("dat1", {

dat1 <- array(1:60, dim = c(time = 5, sdate = 2, member = 6))

func1 <- function(x) {
  res <- if (ii %% 2 == 0) {x} else {x[1:2, ]}
  ii <<- ii + 1
  return(list(res, x))
}

ii <- 1
expect_error(
Apply(dat1, fun = func1, target_dims = c("time", "sdate")),
"Output 'output1' doesn't have consistent output length among chunks."
)
#---------------------------

func2 <- function(x) {
  res <- if (ii %% 2 == 0) {x} else {x[1, ]}
  ii <<- ii + 1
  return(list(out1 = res, out2 = x))
}
ii <- 2
expect_error(
Apply(dat1, fun = func2, target_dims = c("time", "sdate")),
"Output 'out1' doesn't have consistent output length among chunks."
)
#---------------------------

func3 <- function(x) {
  res <- x[1, ]
  return(list(res, x))
}
res <- Apply(dat1, fun = func3, target_dims = c("time", "sdate"))
expect_equal(
dim(res[[1]]),
c(2, member = 6)
)
expect_equal(
dim(res[[2]]),
c(time = 5, sdate = 2, member = 6)
)
#--------------------------------

})


test_that("dat2", {

dat2 <- array(1:60, dim = c(time = 5, member = 7))

func1 <- function(x) {
  res <- if (ii %% 2 == 0) {x} else {x[1:2]}
  ii <<- ii + 1
  return(list(res))
}

ii <- 1
expect_error(
Apply(dat2, fun = func1, target_dims = c("time")),
"Output 'output1' doesn't have consistent output length among chunks."
)
#---------------------------


func2 <- function(x) {
  res <- if (ii %% 2 == 0) {x} else {x[1]}
  ii <<- ii + 1
  return(list(out1 = res, out2 = x))
}
ii <- 1
expect_error(
Apply(dat2, fun = func2, target_dims = c("time")),
"Output 'out1' doesn't have consistent output length among chunks."
)
#---------------------------

func3 <- function(x) {
  res <- x[1]
  return(list(res, x))
}
res <- Apply(dat2, fun = func3, target_dims = c("time"))
expect_equal(
dim(res[[1]]),
c(member = 7)
)
expect_equal(
dim(res[[2]]),
c(time = 5, member = 7)
)
expect_equal(
as.vector(res[[1]]),
seq(1, 31, by = 5)
)
expect_equal(
res[[2]],
dat2
)
#--------------------------------

})


test_that("dat3", {

dat3 <- array(1:15, dim = c(time = 5, member = 3))

func2 <- function(x) {
  res <- if (ii %% 2 == 0) {x} else {as.vector(x[1])}
  ii <<- ii + 1
  return(list(out1 = res))
}
ii <- 1
expect_error(
Apply(dat3, fun = func2, target_dims = c("time")),
"Output 'out1' doesn't have consistent output length among chunks."
)
ii <- 2
expect_error(
Apply(dat3, fun = func2, target_dims = c("time")),
"Output 'out1' doesn't have consistent output length among chunks."
)
#---------------------------

func3 <- function(x) {
  res <- as.vector(x[1:2])
  return(list(res))
}
res <- Apply(dat3, fun = func3, target_dims = "time")

expect_equal(
dim(res[[1]]),
c(2, member = 3)
)
expect_equal(
as.vector(res[[1]]),
c(1, 2, 6, 7, 11, 12)
)
#-------------------------

func4 <- function(x) {
  res <- x[1:2]
  return(list(res))
}
res <- Apply(dat3, fun = func4, target_dims = "time")

expect_equal(
dim(res[[1]]),
c(time = 2, member = 3)
)
expect_equal(
as.vector(res[[1]]),
c(1, 2, 6, 7, 11, 12)
)

})

